var User = require('./user')
module.exports = class Finder {
    constructor(bot) {
        this.bot = bot;
        
    }
    findUserByKey(key,value) {
        var entries = Object.entries(this.bot.rawusers);
        for (var item in entries) {
            if (entries[item][1][key] === value) {
                var user = entries[item][1];
                var usersocketid = entries[item][0];
                return new User(user.nick,user.color,user.home,user.room,usersocketid);
            }
        }
    }
    findUsersByKey(key,value) {
        var entries = Object.entries(this.bot.rawusers);
        var users = []
        for (var item in entries) {
            if (entries[item][1][key] === value) {
                var user = entries[item][1];
                var usersocketid = entries[item][0];
                users.push(new User(user.nick,user.color,user.home,user.room,usersocketid));
            }
        }
        return users;
    }
    findUsersByNickname(nickname) {
        return this.findUsersByKey('nick',nickname)
    }
    findUsersByHome(home) {
        return this.findUsersByKey('home',home)
    }
    findUsersByColor(color) {
        return this.findUsersByKey('color',color)
    }
    findUserBySocketID(id) {
        var entries = Object.entries(this.bot.rawusers);
        for (var item in entries) {
            if (item === id) {
                var user = entries[item][1];
                var usersocketid = entries[item][0];
                return new User(user.nick,user.color,user.home,user.room,usersocketid);
            }
        }
    }
    findUsersByRoom(room) {
        return this.findUsersByKey('room',room)
    }
    
}