// TODO: Finish this and add rooms
Map.prototype.toJSON = function(){
    fjson = {}
    this.forEach((value,itemname) => {
    fjson[itemname] = value;
    })
    return fjson;
    }
module.exports = class Server {
    constructor(port = 8080) {
        var io = require('socket.io')
        var he = require('he')
        var express = require('express')
        var httpsrv = require('http').createServer

        this.app = express();
        this.server = httpsrv();

        this.connections = new Map();
        this.socket = io(this.server);

        this.socket.on('connection',(client) => {
            
            client.on('user joined', (name, color, style, pass) => {
                if (this.connections.get(client.id) == null) {
                    name = he.encode(name);
                

                    this.connections.set(client.id, {nick: name, color: color, style: style, pass: pass})
                    var data = {nick: name, color: color, style: '',date: Date.now()};
                    client.broadcast.emit('user joined', data);
                    client.emit('user joined',data);
                    console.log('User joined!');
                    (()=>{var json=this.connections.toJSON();client.broadcast.emit('update users',json);client.emit('update users',json);})()
                } else {
                    name = he.encode(name);
                
                    var oldata = this.connections.get(client.id)
                    
                    var data = [{nick: oldata.nick, color: oldata.color, home: '', style: '', date: Date.now()},{nick: name, color: color, home: '', style: '',date: Date.now()}];
                    this.connections.set(client.id, {nick: name, color: color, style: style, pass: pass})
                    client.broadcast.emit('user change nick', data[0], data[1]);
                    client.emit('user change nick',data[0], data[1]);
                    console.log('User joined!',data) ;
                    (()=>{var json=this.connections.toJSON();client.broadcast.emit('update users',json);client.emit('update users',json);})()
                }
                
            })
            client.on('message',(msg) => {
                if (this.connections.get(client.id) == null) return;
                //try{
                    var msgs = he.encode(msg);
                /*} catch(err) {
                    console.error(err)
                    client.disconnect()
                    return;
                }*/
                var mdata = {msg: msgs, nick: this.connections.get(client.id).nick,home: 'DYCJ', color: this.connections.get(client.id).color, date: Date.now()}
                client.broadcast.emit("message",mdata);
                client.emit("message",mdata);
                
            })
            client.on('disconnect', () => {
                var userdata = this.connections.get(client.id);
                if (userdata == null) return;
                var data = {
                    nick: userdata.nick,
                    color: userdata.color,
                    style: '',
                    date: Date.now()
                }
                client.broadcast.emit('user left',data);
                this.connections.delete(client.id);
                (()=>{var json=this.connections.toJSON();client.broadcast.emit('update users',json);client.emit('update users',json);})()
            })
        })
    }
    listen(port, callback = () => {}) {
        this.server.listen(port, callback);
    }
    
}