module.exports = class User {
    constructor(name, color, home, room = "atrium", socketid = null) {
        var he = require('he')
        var uuidv4 = require('../utils/uuid.js').uuidv4
        try{
            this.name = he.decode(name)
        }catch(err){
            // Fallback
            this.name = name;
        };
        this.color = color == "" ? "white" : color;
        this.uuid = uuidv4(name+color+home);
        this.home = home;
        this.room = room;
        this.socketid = socketid;

    }
    toString() {
        return this.name
    }
}