var Trollbox = require('.');
var he = require('he')

var bot = new Trollbox.Bot();
pplrooms = {}

bot.setName('ZBot');
bot.setPrefix("z>");
//setTimeout(() => bot.setRoom('bots'),1000)

/*bot.use((event) => {
    event.data.nick = event.data.nick.replace('ShyGuyMask','Supreme owner')
})*/

bot.on('join room', (data) => {
    console.log(`${data.nick} Joined The Room: ${data.room}`);
    if (data.nick == bot.name) return;
    if (data.room == "atrium") return;

    if (pplrooms[data.room] == null) pplrooms[data.room] = []
    for (var key in pplrooms) {
        if (pplrooms[key].includes(data.nick)) {
            pplrooms[key].splice(pplrooms[key].indexOf(data.nick),1);
        }
    }
    pplrooms[data.room].push(data.nick)
});
bot.on('left', (data) => {
    for (var key in pplrooms) {
        if (pplrooms[key].includes(data.name)) {
            pplrooms[key].splice(pplrooms[key].indexOf(data.name))
        }
    }
})

bot.on('message',(data) => console.log(data.content))

bot.commands.set('ping',(cmd) => {
    bot.send('Pong '+cmd.message.user.name+' !')
})
bot.commands.set('connected',(cmd) => {
    bot.send(`There are ${Object.keys(bot.users).length+1} Users Connected!`)
})
bot.commands.set('bottest',(cmd) => {
    bot.setRoom("bot-test")
})
bot.commands.set('defaultr',(cmd) => {
    bot.defaultRoom()
})
bot.commands.set('getrooms',async (cmd) => {
    rooms = await bot.getRooms()
    org = ""
    rooms.forEach((room) => {
        org += `${room.name} Online: ${room.online}\n`
    });
console.log(`
Rooms:
${org}

`)
    bot.send(`
Rooms:
${org}

`)
})
bot.commands.set('color', (cmd) => {
bot.changeColor(cmd.arguments[0])
})
bot.commands.set('goto', (cmd) => {
    bot.setRoom(cmd.arguments.join(' '))
    })
bot.commands.set('gay', (cmd) => {
    bot.send(cmd.message.user.name.replace('hugs','duck')+" Is now gay!")
})
bot.commands.set('testserver', (cmd) => {
    bot.send("Minecraft Java Server: lagme.aternos.me:25565")
})
bot.commands.set('pplrooms', (cmd) => {
    /*fstr = "";
    for (var key in pplrooms) {
        fstr += `${key}: ${pplrooms[key].join(', ')}\n`
    }
    bot.send(`
Rooms People are:
${fstr}
        `)*/
        rooms = {}
        for (var item in bot.rawusers) {
            if (bot.rawusers[item].room != "atrium") {
                if (rooms[bot.rawusers[item].room] == null) {rooms[bot.rawusers[item].room] = []}
                rooms[bot.rawusers[item].room].push(bot.rawusers[item])
            }
        }
        // Mixing the old method with the new one for real-time changes
        for (var item in pplrooms) {
            if (rooms[item] == null) rooms[item] = []
            if (!rooms[item].includes(pplrooms[item])) {
                //rooms[item].push(pplrooms[item])
                pplrooms[item].forEach((name) => {
                    if (typeof name != "string") return;
                    rooms[item].push(name)
                })
            }
        }
        fstr = ""
        for (var item in rooms) {
            fstr += `${item}: ${rooms[item].map((a,b) => {if(typeof a != "string") {return he.decode(a.nick)} else {return a}}).join(', ')}\n`
            rooms[item]
        }
        bot.send(`
Rooms people are:
${fstr}`);
        console.log(rooms)
})
bot.commands.set('bestroom', async (cmd) => {
    rooms = await bot.getRooms();
    rooms = rooms.splice(1)
    roomsb = rooms.sort((a,b) => {return b.online-a.online});
    fstr = ""
    roomsb.forEach((room) => {
        fstr += `${room.name}\n`
    })

    setTimeout(() => bot.send(`Best Room To Join: ${roomsb[0].name}`),1500)

})
bot.commands.set('help', (cmd) => {
    arraycmds = []
    bot.commands.forEach((a,b) => {
        arraycmds.push(b)
    })
    bot.send(`Commands: ${arraycmds.join(', ')}`)
})
        

bot.connect();